All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # This program is licensed under the GNU GPL version 2 or later.
4 # (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2015
5 # For details, see LICENSE. To submit patches, you have to agree to
6 # license your code under the GNU GPL version 2 or later.
8 # While the following is not legally binding, the author would like to
9 # explain the choice of GPLv2+ over GPLv3+.
10 # The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
11 # full compatibility's with Git. In case Git ever changes its licensing terms,
12 # which is admittedly extremely unlikely to the point of being impossible,
13 # this software will most likely follow suit.
15 # This should always be the first line of code to facilitate debugging
16 [ -n "$VCSH_DEBUG" ] && set -vx
19 # If '.git-HEAD' is appended to the version, you are seeing an unreleased
20 # version of vcsh; the master branch is supposed to be clean at all times
21 # so you can most likely just use it nonetheless
25 # Ensure all files created are accessible only to the current user.
29 echo "$SELF: fatal: $1" >&2
34 # We need to run getops as soon as possible so we catch -d and other
35 # options that will modify our behaviour.
36 # Commands are handled at the end of this script.
37 while getopts "c:dv" flag; do
38 if [ x"$1" = x'-d' ] || [ x"$1" = x'--debug' ]; then
43 elif [ x"$1" = x'-v' ]; then
45 echo "verbose mode on"
47 elif [ x"$1" = x'-c' ]; then
48 VCSH_OPTION_CONFIG=$OPTARG
54 # Source file even if it's in $PWD and does not have any slashes in it
62 # Read configuration and set defaults if anything's not set
63 [ -n "$VCSH_DEBUG" ] && set -vx
64 : ${XDG_CONFIG_HOME:="$HOME/.config"}
66 # Read configuration files if there are any
67 [ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
68 [ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
69 if [ -n "$VCSH_OPTION_CONFIG" ]; then
70 # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
71 if [ -r "$VCSH_OPTION_CONFIG" ]; then
72 source_all "$VCSH_OPTION_CONFIG"
74 fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
77 [ -n "$VCSH_DEBUG" ] && set -vx
80 : ${VCSH_REPO_D:="$XDG_CONFIG_HOME/vcsh/repo.d"}
81 : ${VCSH_HOOK_D:="$XDG_CONFIG_HOME/vcsh/hooks-enabled"}
82 : ${VCSH_OVERLAY_D:="$XDG_CONFIG_HOME/vcsh/overlays-enabled"}
83 : ${VCSH_BASE:="$HOME"}
84 : ${VCSH_GITIGNORE:=exact}
85 : ${VCSH_GITATTRIBUTES:=none}
86 : ${VCSH_WORKTREE:=absolute}
88 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
89 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
92 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ] && [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
93 fatal "'\$VCSH_WORKTREE' must equal 'absolute', or 'relative'" 1
98 echo "usage: $SELF <options> <command>
101 -c <file> Source file
103 -v Enable verbose mode
106 clone [-b <branch>] \\
108 [<repo>] Clone from an existing repository
109 commit Commit in all repositories
110 delete <repo> Delete an existing repository
111 enter <repo> Enter repository; spawn new instance of \$SHELL
113 <git command> Execute a command for every repository
114 help Display this help text
115 init <repo> Initialize a new repository
116 list List all repositories
118 [<repo>] List all files tracked all or one repositories
121 [<repo>] List all files not tracked by all or one repositories
122 pull Pull from all vcsh remotes
123 push Push to vcsh remotes
125 <newname> Rename repository
127 <command> Use this repository
129 [--terse] [<repo>] Show statuses of all/one vcsh repositories
130 upgrade <repo> Upgrade repository to currently recommended settings
131 version Print version information
132 which <substring> Find substring in name of any tracked file
134 <repo> Write .gitignore.d/<repo> via git ls-files
136 <repo> <git command> Shortcut to run git commands directly
137 <repo> Shortcut to enter repository" >&2
141 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
145 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
149 echo "$SELF: error: $1" >&2
153 echo "$SELF: info: $1"
159 git remote add origin "$GIT_REMOTE"
160 git checkout -b "$VCSH_BRANCH" || return $?
161 git config branch."$VCSH_BRANCH".remote origin
162 git config branch."$VCSH_BRANCH".merge refs/heads/"$VCSH_BRANCH"
163 if [ $(git ls-remote origin "$VCSH_BRANCH" 2> /dev/null | wc -l ) -lt 1 ]; then
164 info "remote is empty, not merging anything.
165 You should add files to your new repository."
168 GIT_VERSION_MAJOR=$(git --version | sed -n 's/.* \([0-9]\)\..*/\1/p' )
169 if [ 1 -lt "$GIT_VERSION_MAJOR" ];then
170 git fetch origin "$VCSH_BRANCH"
175 git ls-tree -r --name-only origin/"$VCSH_BRANCH" | (while read object; do
177 error "'$object' exists." &&
180 [ x"$VCSH_CONFLICT" = x'1' ]) &&
181 fatal "will stop after fetching and not try to merge!
182 Once this situation has been resolved, run 'vcsh $VCSH_REPO_NAME pull' to finish cloning." 17
183 git -c merge.ff=true merge origin/"$VCSH_BRANCH"
187 hook post-clone-retired
192 for VCSH_REPO_NAME in $(list); do
193 echo "$VCSH_REPO_NAME: "
194 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
196 git commit --untracked-files=no --quiet $@
197 VCSH_COMMAND_RETURN_CODE=$?
204 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
206 info "This operation WILL DESTROY DATA!"
207 files=$(git ls-files)
208 echo "These files will be deleted:
212 AGAIN, THIS WILL DELETE YOUR DATA!
213 To continue, type 'Yes, do as I say'"
215 [ "x$answer" = 'xYes, do as I say' ] || exit 16
216 for file in $files; do
217 rm -f $file || info "could not delete '$file', continuing with deletion"
219 rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
232 # We default to prefixing `git` to all commands passed to foreach, but
233 # allow running in general context with -g
235 while getopts "g" flag; do
236 if [ x"$1" = x'-g' ]; then
241 for VCSH_REPO_NAME in $(list); do
242 echo "$VCSH_REPO_NAME:"
243 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
251 [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
255 for hook in "$VCSH_HOOK_D/$1"* "$VCSH_HOOK_D/$VCSH_REPO_NAME.$1"*; do
256 [ -x "$hook" ] || continue
257 verbose "executing '$hook'"
264 [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
265 mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
266 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
267 git init --shared=false
273 for repo in "$VCSH_REPO_D"/*.git; do
274 [ -d "$repo" ] && [ -r "$repo" ] && echo "$(basename "$repo" .git)"
279 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
284 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
285 if [ -n "$VCSH_REPO_NAME" ]; then
286 get_files | list_tracked_helper
288 for VCSH_REPO_NAME in $(list); do
290 done | list_tracked_helper
294 list_tracked_helper() {
295 sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | sed 's/[,\&]/\\&/g')," | sort -u
303 command -v 'comm' >/dev/null 2>&1 || fatal "Could not find 'comm'"
305 temp_file_others=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
306 temp_file_untracked=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
307 temp_file_untracked_copy=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
309 # Hack in support for `vcsh list-untracked -r`...
310 exclude_standard_opt='--exclude-standard'
311 directory_opt="--directory"
313 while getopts "ar" flag; do
314 if [ x"$1" = x'-a' ]; then
315 unset exclude_standard_opt
316 elif [ x"$1" = x'-r' ]; then
321 # ...and parse for a potential parameter afterwards. As we shifted things out of $* in during getops, we need to look at $1
322 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
324 if [ -n "$VCSH_REPO_NAME" ]; then
325 list_untracked_helper $VCSH_REPO_NAME
327 for VCSH_REPO_NAME in $(list); do
328 list_untracked_helper $VCSH_REPO_NAME
331 cat $temp_file_untracked
333 unset directory_opt directory_component
334 rm -f $temp_file_others $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not delete temp files'
337 list_untracked_helper() {
338 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
339 git ls-files --others $exclude_standard_opt "$directory_opt" | (
342 directory_component=${line%%/*}
343 [ -d "$directory_component" ] && printf '%s/\n' "$directory_component"
345 ) | sort -u > $temp_file_others
346 if [ -z "$ran_once" ]; then
348 cp $temp_file_others $temp_file_untracked || fatal 'Could not copy temp file'
350 cp $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not copy temp file'
351 comm -12 $temp_file_others $temp_file_untracked_copy > $temp_file_untracked
356 for VCSH_REPO_NAME in $(list); do
357 printf '%s: ' "$VCSH_REPO_NAME"
358 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
361 VCSH_COMMAND_RETURN_CODE=$?
369 for VCSH_REPO_NAME in $(list); do
370 printf '%s: ' "$VCSH_REPO_NAME"
371 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
374 VCSH_COMMAND_RETURN_CODE=$?
386 [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
387 mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
389 # Now that the repository has been renamed, we need to fix up its configuration
390 # Overwrite old name..
392 VCSH_REPO_NAME=$VCSH_REPO_NAME_NEW
393 # ..and clobber all old configuration
401 VCSH_COMMAND_RETURN_CODE=$?
407 COLORING="-c color.status=always"
409 if [ -n "$VCSH_REPO_NAME" ]; then
410 status_helper $VCSH_REPO_NAME
412 for VCSH_REPO_NAME in $(list); do
413 STATUS=$(status_helper $VCSH_REPO_NAME "$COLORING")
414 [ -n "$STATUS" -o -z "$VCSH_STATUS_TERSE" ] && echo "$VCSH_REPO_NAME:"
415 [ -n "$STATUS" ] && echo "$STATUS"
416 [ -z "$VCSH_STATUS_TERSE" ] && echo
422 GIT_DIR=$VCSH_REPO_D/$1.git; export GIT_DIR
425 remote_tracking_branch=$(git rev-parse --abbrev-ref --symbolic-full-name @{u} 2> /dev/null) && {
426 commits_behind=$(git log ..${remote_tracking_branch} --oneline | wc -l)
427 commits_ahead=$(git log ${remote_tracking_branch}.. --oneline | wc -l)
428 [ ${commits_behind} -ne 0 ] && echo "Behind $remote_tracking_branch by $commits_behind commits"
429 [ ${commits_ahead} -ne 0 ] && echo "Ahead of $remote_tracking_branch by $commits_ahead commits"
431 git ${VCSH_GIT_OPTIONS} status --short --untracked-files='no'
432 VCSH_COMMAND_RETURN_CODE=$?
437 # fake-bare repositories are not bare, actually. Set this to false
438 # because otherwise Git complains "fatal: core.bare and core.worktree
440 git config core.bare false
441 # core.worktree may be absolute or relative to $GIT_DIR, depending on
443 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ]; then
444 git config core.worktree "$(cd "$GIT_DIR" && GIT_WORK_TREE=$VCSH_BASE git rev-parse --show-cdup)"
445 elif [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
446 git config core.worktree "$VCSH_BASE"
448 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
449 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && git config core.attributesfile ".gitattributes.d/$VCSH_REPO_NAME"
450 git config vcsh.vcsh 'true'
452 [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
453 [ -e "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME"
459 VCSH_DIRECTORY=$VCSH_REPO_NAME; export VCSH_DIRECTORY
463 output=$(for VCSH_REPO_NAME in $(list); do
464 get_files | grep -- "$VCSH_COMMAND_PARAMETER" | sed "s/^/$VCSH_REPO_NAME: /"
466 if [ -z "$output" ]; then
467 fatal "'$VCSH_COMMAND_PARAMETER' does not exist" 1
474 # Don't do anything if the user does not want to write gitignore
475 if [ "x$VCSH_GITIGNORE" = 'xnone' ]; then
476 info "Not writing gitignore as '\$VCSH_GITIGNORE' is set to 'none'"
481 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
482 local GIT_VERSION="$(git --version)"
483 local GIT_VERSION_MAJOR=$(echo $GIT_VERSION | sed -n 's/.* \([0-9]\)\..*/\1/p')
484 local GIT_VERSION_MINOR=$(echo $GIT_VERSION | sed -n 's/.* \([0-9]\)\.\([0-9]\)\..*/\2/p')
487 gitignores=$(for file in $(git ls-files); do
488 if [ $GIT_VERSION_MAJOR -ge 2 -a $GIT_VERSION_MINOR -ge 7 ]; then
492 echo "$file"; new=${file%/*}
493 [ x"$file" = x"$new" ] && break
499 # Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files
500 # Using a template makes GNU mktemp default to $PWD and not #TMPDIR for tempfile location
501 # To make every OS happy, set full path explicitly
502 tempfile=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal "could not create tempfile: '${tempfile}'" 51
504 echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
505 for gitignore in $gitignores; do
506 echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
507 if [ "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ -d "$gitignore" ]; then
508 { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
512 if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
513 rm -f "$tempfile" || error "could not delete '$tempfile'"
516 if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
517 info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
518 mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
519 fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
521 mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
522 fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
527 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
528 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
531 VCSH_COMMAND=$1; export VCSH_COMMAND
533 case $VCSH_COMMAND in
534 clon|clo|cl) VCSH_COMMAND=clone;;
535 commi|comm|com|co) VCSH_COMMAND=commit;;
536 delet|dele|del|de) VCSH_COMMAND=delete;;
537 ente|ent|en) VCSH_COMMAND=enter;;
538 hel|he) VCSH_COMMAND=help;;
539 ini|in) VCSH_COMMAND=init;;
540 pul) VCSH_COMMAND=pull;;
541 pus) VCSH_COMMAND=push;;
542 renam|rena|ren|re) VCSH_COMMAND=rename;;
543 ru) VCSH_COMMAND=run;;
544 statu|stat|sta|st) VCSH_COMMAND=status;;
545 upgrad|upgra|upgr|up) VCSH_COMMAND=upgrade;;
546 versio|versi|vers|ver|ve) VCSH_COMMAND=version;;
547 which|whi|wh) VCSH_COMMAND=which;;
548 write|writ|wri|wr) VCSH_COMMAND=write-gitignore;;
551 if [ x"$VCSH_COMMAND" = x'clone' ]; then
553 if [ "$2" = -b ]; then
558 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
560 [ -n "$VCSH_BRANCH" ] || if [ "$3" = -b ]; then
567 [ -z "$VCSH_BRANCH" ] && [ "$4" = -b ] && VCSH_BRANCH=$5
569 VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
571 [ -z "$VCSH_REPO_NAME" ] && fatal "$VCSH_COMMAND: could not determine repository name" 1
572 export VCSH_REPO_NAME
573 [ -n "$VCSH_BRANCH" ] || VCSH_BRANCH=master
574 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
575 elif [ "$VCSH_COMMAND" = 'version' ]; then
576 echo "$SELF $VERSION"
579 elif [ x"$VCSH_COMMAND" = x'which' ]; then
580 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a filename" 1
581 [ -n "$3" ] && fatal "$VCSH_COMMAND: too many parameters" 1
582 VCSH_COMMAND_PARAMETER=$2; export VCSH_COMMAND_PARAMETER
583 elif [ x"$VCSH_COMMAND" = x'delete' ] ||
584 [ x"$VCSH_COMMAND" = x'enter' ] ||
585 [ x"$VCSH_COMMAND" = x'init' ] ||
586 [ x"$VCSH_COMMAND" = x'list-tracked-by' ] ||
587 [ x"$VCSH_COMMAND" = x'rename' ] ||
588 [ x"$VCSH_COMMAND" = x'run' ] ||
589 [ x"$VCSH_COMMAND" = x'upgrade' ] ||
590 [ x"$VCSH_COMMAND" = x'write-gitignore' ]; then
591 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify repository to work on" 1
592 [ x"$VCSH_COMMAND" = x'rename' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a target name" 1
593 [ x"$VCSH_COMMAND" = x'run' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a command" 1
594 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
595 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
596 [ x"$VCSH_COMMAND" = x'rename' ] && { VCSH_REPO_NAME_NEW=$3; export VCSH_REPO_NAME_NEW;
597 GIT_DIR_NEW=$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git; export GIT_DIR_NEW; }
598 [ x"$VCSH_COMMAND" = x'run' ] && shift 2
599 elif [ x"$VCSH_COMMAND" = x'foreach' ]; then
600 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a command" 1
602 elif [ x"$VCSH_COMMAND" = x'commit' ] ||
603 [ x"$VCSH_COMMAND" = x'list' ] ||
604 [ x"$VCSH_COMMAND" = x'list-tracked' ] ||
605 [ x"$VCSH_COMMAND" = x'list-untracked' ] ||
606 [ x"$VCSH_COMMAND" = x'pull' ] ||
607 [ x"$VCSH_COMMAND" = x'push' ]; then
609 elif [ x"$VCSH_COMMAND" = x'status' ]; then
610 if [ x"$2" = x'--terse' ]; then
611 VCSH_STATUS_TERSE=1; export VCSH_STATUS_TERSE
614 VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
615 elif [ -n "$2" ]; then
616 VCSH_COMMAND='run'; export VCSH_COMMAND
617 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
618 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
619 [ -d "$GIT_DIR" ] || { help; exit 1; }
622 elif [ -n "$VCSH_COMMAND" ]; then
623 VCSH_COMMAND='enter'; export VCSH_COMMAND
624 VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
625 GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
626 [ -d "$GIT_DIR" ] || { help; exit 1; }
628 # $1 is empty, or 'help'
632 # Did we receive a directory instead of a name?
633 # Mangle the input to fit normal operation.
634 if echo "$VCSH_REPO_NAME" | grep -q '/'; then
635 GIT_DIR=$VCSH_REPO_NAME; export GIT_DIR
636 VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git); export VCSH_REPO_NAME
641 if [ ! -d "$check_directory" ]; then
642 if [ -e "$check_directory" ]; then
643 fatal "'$check_directory' exists but is not a directory" 13
645 verbose "attempting to create '$check_directory'"
646 mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
651 check_dir "$VCSH_REPO_D"
652 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && check_dir "$VCSH_BASE/.gitignore.d"
653 [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && check_dir "$VCSH_BASE/.gitattributes.d"
655 verbose "$VCSH_COMMAND begin"
656 VCSH_COMMAND=$(echo "$VCSH_COMMAND" | sed 's/-/_/g'); export VCSH_COMMAND
658 # Source repo-specific configuration file
659 [ -r "$XDG_CONFIG_HOME/vcsh/config.d/$VCSH_REPO_NAME" ] && . "$XDG_CONFIG_HOME/vcsh/config.d/$VCSH_REPO_NAME"
661 # source overlay functions
662 for overlay in "$VCSH_OVERLAY_D/$VCSH_COMMAND"* "$VCSH_OVERLAY_D/$VCSH_REPO_NAME.$VCSH_COMMAND"*; do
663 [ -r "$overlay" ] || continue
664 info "sourcing '$overlay'"
671 verbose "$VCSH_COMMAND end, exiting"
672 exit $VCSH_COMMAND_RETURN_CODE